Index: java/main/src/main/java/com/framsticks/gui/table/ListPanel.java
===================================================================
--- java/main/src/main/java/com/framsticks/gui/table/ListPanel.java	(revision 99)
+++ java/main/src/main/java/com/framsticks/gui/table/ListPanel.java	(revision 100)
@@ -3,11 +3,12 @@
 
 import com.framsticks.gui.ModifiablePanel;
-import com.framsticks.params.AccessInterface;
+import com.framsticks.params.Access;
 import com.framsticks.params.ListAccess;
-import com.framsticks.params.PrimitiveParam;
+import com.framsticks.params.Param;
+import com.framsticks.util.FramsticksException;
 import com.framsticks.util.lang.Casting;
-import com.framsticks.util.lang.Containers;
 
-import org.apache.log4j.Logger;
+import org.apache.logging.log4j.Logger;
+import org.apache.logging.log4j.LogManager;
 
 import javax.swing.*;
@@ -19,5 +20,5 @@
 public class ListPanel extends ModifiablePanel {
 
-	private static final Logger log = Logger.getLogger(ListPanel.class.getName());
+	private static final Logger log = LogManager.getLogger(ListPanel.class.getName());
 
 	protected final TableModel tableModel;
@@ -29,21 +30,29 @@
 
 		final ColumnsConfig config = provider.getColumnsConfigs().get(framsClass.getName());
-		log.debug("creating ListPanel for " + parameters.framsClass + " using config " + config);
+		log.debug("creating ListPanel for {} using config {}", parameters.framsClass, config);
 
-		tableModel = new TableModel();
+		tableModel = new TableModel(this);
 		if (config != null) {
 			for (String id : config.getColumnsNames()) {
-				tableModel.addColumn(framsClass.getParamEntry(id, PrimitiveParam.class));
+				Param param = framsClass.getParam(id);
+				if (param == null) {
+					throw new FramsticksException().msg("requested param not found in frams class").arg("param", id).arg("frams class", framsClass);
+				}
+				if (!tableModel.addColumnIfSupported(param)) {
+					throw new FramsticksException().msg("param is not supported in table view").arg("param", param).arg("frams class", framsClass);
+				}
 			}
 		} else {
-			for (PrimitiveParam<?> param : Containers.filterInstanceof(framsClass.getParamEntries(), PrimitiveParam.class)) {
+			for (Param param : framsClass.getParamEntries()) {
 				if (provider.getMaximumColumnNumber() != null && tableModel.getColumnCount() >= provider.getMaximumColumnNumber()) {
 					break;
 				}
-				tableModel.addColumn(param);
+				tableModel.addColumnIfSupported(param);
 			}
 		}
 
 		table = new JTable(tableModel);
+		tableModel.setupTable();
+
 		scrollPane = new JScrollPane(table);
 		setupContentComponent(scrollPane);
@@ -63,5 +72,5 @@
 
 	@Override
-	public void pullValuesFromLocalToUser(AccessInterface access) {
+	public void pullValuesFromLocalToUser(Access access) {
 		tableModel.attachSource(Casting.throwCast(ListAccess.class, access));
 	}
@@ -71,3 +80,10 @@
 		return "List";
 	}
+
+	/**
+	 * @return the table
+	 */
+	public JTable getTable() {
+		return table;
+	}
 }
Index: java/main/src/main/java/com/framsticks/gui/table/ListPanelProvider.java
===================================================================
--- java/main/src/main/java/com/framsticks/gui/table/ListPanelProvider.java	(revision 99)
+++ java/main/src/main/java/com/framsticks/gui/table/ListPanelProvider.java	(revision 100)
@@ -5,6 +5,6 @@
 import java.util.Map;
 
-import com.framsticks.gui.Panel;
 import com.framsticks.gui.PanelProvider;
+import com.framsticks.gui.TreePanel;
 import com.framsticks.params.annotations.AutoAppendAnnotation;
 import com.framsticks.params.annotations.FramsClassAnnotation;
@@ -22,5 +22,5 @@
 
 	@Override
-	public Panel providePanel(Panel.Parameters parameters) {
+	public TreePanel providePanel(TreePanel.Parameters parameters) {
 		if (parameters.param instanceof ListParam) {
 			return new ListPanel(parameters, this);
Index: java/main/src/main/java/com/framsticks/gui/table/PrimitiveColumn.java
===================================================================
--- java/main/src/main/java/com/framsticks/gui/table/PrimitiveColumn.java	(revision 100)
+++ java/main/src/main/java/com/framsticks/gui/table/PrimitiveColumn.java	(revision 100)
@@ -0,0 +1,41 @@
+package com.framsticks.gui.table;
+
+import com.framsticks.params.PrimitiveParam;
+import com.framsticks.util.UnsupportedOperationException;
+
+public class PrimitiveColumn extends Column {
+
+	public PrimitiveColumn(PrimitiveParam<?> param, TableModel tableModel) {
+		super(param, tableModel);
+	}
+
+	@Override
+	public PrimitiveParam<?> getParam() {
+		return (PrimitiveParam<?>) param;
+	}
+
+	@Override
+	public Class<?> getColumnClass() {
+		return getParam().getStorageType();
+	}
+
+	@Override
+	public Object getValueAt(int rowIndex) {
+		Object object = tableModel.getAccess().get(rowIndex, Object.class);
+		if (object == null) {
+			return null;
+		}
+		return tableModel.getElementAccess().select(object).get(getParam(), Object.class);
+	}
+
+	@Override
+	public int setValueAt(int rowIndex, Object value) {
+		throw new UnsupportedOperationException().msg("setting value in table");
+	}
+
+	@Override
+	public boolean isEditable() {
+		return false;
+	}
+
+}
Index: java/main/src/main/java/com/framsticks/gui/table/ProcedureColumn.java
===================================================================
--- java/main/src/main/java/com/framsticks/gui/table/ProcedureColumn.java	(revision 100)
+++ java/main/src/main/java/com/framsticks/gui/table/ProcedureColumn.java	(revision 100)
@@ -0,0 +1,49 @@
+package com.framsticks.gui.table;
+
+
+import com.framsticks.core.Path;
+import com.framsticks.gui.controls.ProcedureControl;
+import com.framsticks.params.CompositeParam;
+import com.framsticks.params.types.ProcedureParam;
+
+public class ProcedureColumn extends Column {
+
+	public ProcedureColumn(ProcedureParam param, TableModel tableModel) {
+		super(param, tableModel);
+	}
+
+	@Override
+	public ProcedureParam getParam() {
+		return (ProcedureParam) param;
+	}
+
+	@Override
+	public Class<?> getColumnClass() {
+		return ProcedureParam.class;
+	}
+
+	@Override
+	public Object getValueAt(int rowIndex) {
+		return param;
+	}
+
+	@Override
+	public int setValueAt(int rowIndex, Object value) {
+		CompositeParam param = tableModel.getAccess().getCompositeParam(rowIndex);
+		if (param == null) {
+			return 0;
+		}
+		Path path = tableModel.getListPanel().getCurrentPath().appendParam(param).tryFindResolution();
+		if (!path.isResolved()) {
+			return 0;
+		}
+		ProcedureControl.callProcedure(path, getParam(), new Object[] {});
+		return 0;
+	}
+
+	@Override
+	public boolean isEditable() {
+		return true;
+	}
+
+}
Index: java/main/src/main/java/com/framsticks/gui/table/ProcedureEditor.java
===================================================================
--- java/main/src/main/java/com/framsticks/gui/table/ProcedureEditor.java	(revision 100)
+++ java/main/src/main/java/com/framsticks/gui/table/ProcedureEditor.java	(revision 100)
@@ -0,0 +1,63 @@
+package com.framsticks.gui.table;
+
+import java.awt.Component;
+import java.awt.event.ActionEvent;
+import java.awt.event.ActionListener;
+
+import javax.swing.DefaultCellEditor;
+import javax.swing.JButton;
+import javax.swing.JCheckBox;
+import javax.swing.JTable;
+
+import com.framsticks.params.types.ProcedureParam;
+import com.framsticks.util.lang.Casting;
+
+@SuppressWarnings("serial")
+public class ProcedureEditor extends DefaultCellEditor {
+
+	protected JButton button;
+
+	private ProcedureParam procedure;
+
+	private boolean isPushed;
+
+	public ProcedureEditor(JCheckBox checkBox) {
+		super(checkBox);
+		button = new JButton();
+		button.setOpaque(true);
+		button.addActionListener(new ActionListener() {
+			public void actionPerformed(ActionEvent e) {
+				fireEditingStopped();
+			}
+		});
+	}
+
+	public Component getTableCellEditorComponent(JTable table, Object value, boolean isSelected, int row, int column) {
+		TableModel.transferCellAppeariance(table, button, isSelected);
+		procedure = Casting.assertCast(ProcedureParam.class, value);
+		button.setText(procedure.getName());
+		isPushed = true;
+		return button;
+	}
+
+	public Object getCellEditorValue() {
+		if (isPushed) {
+			//
+			//
+			// JOptionPane.showMessageDialog(button, label + ": Ouch!");
+			// System.out.println(label + ": Ouch!");
+		}
+		isPushed = false;
+		return procedure;
+	}
+
+	public boolean stopCellEditing() {
+		isPushed = false;
+		return super.stopCellEditing();
+	}
+
+	protected void fireEditingStopped() {
+		super.fireEditingStopped();
+	}
+
+}
Index: java/main/src/main/java/com/framsticks/gui/table/ProcedureRenderer.java
===================================================================
--- java/main/src/main/java/com/framsticks/gui/table/ProcedureRenderer.java	(revision 100)
+++ java/main/src/main/java/com/framsticks/gui/table/ProcedureRenderer.java	(revision 100)
@@ -0,0 +1,24 @@
+package com.framsticks.gui.table;
+
+import java.awt.Component;
+
+import javax.swing.JButton;
+import javax.swing.JTable;
+import javax.swing.table.TableCellRenderer;
+
+import com.framsticks.params.types.ProcedureParam;
+
+@SuppressWarnings("serial")
+class ProcedureRenderer extends JButton implements TableCellRenderer {
+
+	public ProcedureRenderer() {
+		setOpaque(true);
+	}
+
+	public Component getTableCellRendererComponent(JTable table, Object value, boolean isSelected, boolean hasFocus, int row, int column) {
+		// log.info("focus: {}", hasFocus);
+		TableModel.transferCellAppeariance(table, this, isSelected);
+		setText(((ProcedureParam) value).getName());
+		return this;
+	}
+}
Index: java/main/src/main/java/com/framsticks/gui/table/TableModel.java
===================================================================
--- java/main/src/main/java/com/framsticks/gui/table/TableModel.java	(revision 99)
+++ java/main/src/main/java/com/framsticks/gui/table/TableModel.java	(revision 100)
@@ -6,24 +6,49 @@
 import java.util.List;
 
+import javax.swing.JCheckBox;
+import javax.swing.JComponent;
+import javax.swing.JTable;
+import javax.swing.UIManager;
 import javax.swing.event.TableModelEvent;
 import javax.swing.event.TableModelListener;
 
-import org.apache.log4j.Logger;
+import org.apache.logging.log4j.Logger;
+import org.apache.logging.log4j.LogManager;
 
-import com.framsticks.params.AccessInterface;
+import com.framsticks.params.Access;
 import com.framsticks.params.ListAccess;
+import com.framsticks.params.Param;
 import com.framsticks.params.PrimitiveParam;
-import com.framsticks.util.UnsupportedOperationException;
+import com.framsticks.params.types.ProcedureParam;
 import com.framsticks.util.lang.Casting;
 
 public class TableModel implements javax.swing.table.TableModel {
-	private static final Logger log =
-		Logger.getLogger(TableModel.class);
 
+	private static final Logger log = LogManager.getLogger(TableModel.class);
 
 	protected List<TableModelListener> listeners = new LinkedList<>();
 	protected ListAccess access;
-	protected AccessInterface elementAccess;
-	protected final List<PrimitiveParam<?>> columnParams = new ArrayList<>();
+	protected Access elementAccess;
+	protected final List<Column> columns = new ArrayList<>();
+	protected final ListPanel listPanel;
+	protected JTable table;
+
+	/**
+	 * @param listPanel
+	 */
+	public TableModel(ListPanel listPanel) {
+		this.listPanel = listPanel;
+	}
+
+	/**
+	 * @return the listPanel
+	 */
+	public ListPanel getListPanel() {
+		return listPanel;
+	}
+
+	public JTable getTable() {
+		return listPanel.getTable();
+	}
 
 	protected void refreshAll() {
@@ -31,5 +56,12 @@
 			l.tableChanged(new TableModelEvent(this));
 		}
+	}
 
+	/**
+	 * @param table the table to set
+	 */
+	public void setupTable() {
+		getTable().setDefaultRenderer(ProcedureParam.class, new ProcedureRenderer());
+		getTable().setDefaultEditor(ProcedureParam.class, new ProcedureEditor(new JCheckBox()));
 	}
 
@@ -38,5 +70,5 @@
 
 		this.elementAccess = this.access.getElementAccess().cloneAccess();
-		log.debug("attached " + access);
+		log.debug("attached {}", access);
 		refreshAll();
 	}
@@ -49,35 +81,35 @@
 	@Override
 	public Class<?> getColumnClass(int columnIndex) {
-		// log.debug("returning column type " + columnParams.get(columnIndex).getStorageType());
-		return columnParams.get(columnIndex).getStorageType();
+		// log.debug("returning column type {}", columnParams.get(columnIndex).getStorageType());
+		return columns.get(columnIndex).getColumnClass();
 	}
 
 	@Override
 	public int getColumnCount() {
-		// log.debug("returning column count " + columnParams.size());
-		return columnParams.size();
+		// log.debug("returning column count {}", columnParams.size());
+		return columns.size();
 	}
 
 	@Override
 	public String getColumnName(int columnIndex) {
-		return columnParams.get(columnIndex).getName();
+		return columns.get(columnIndex).getParam().getName();
 	}
 
 	@Override
 	public int getRowCount() {
-		// log.debug("returning row count " + access.getParamCount());
-		return access.getParamCount();
+		// log.debug("returning row count {}", access.getParamCount());
+		return access == null ? 0 : access.getParamCount();
 	}
 
 	@Override
 	public Object getValueAt(int rowIndex, int columnIndex) {
-		assert (rowIndex < access.getParamCount() && columnIndex < columnParams.size());
+		assert (rowIndex < access.getParamCount() && columnIndex < columns.size());
 
-		return elementAccess.select(access.get(rowIndex, Object.class)).get(columnParams.get(columnIndex), Object.class);
+		return columns.get(columnIndex).getValueAt(rowIndex);
 	}
 
 	@Override
 	public boolean isCellEditable(int rowIndex, int columnIndex) {
-		return false;
+		return columns.get(columnIndex).isEditable();
 	}
 
@@ -87,13 +119,32 @@
 	}
 
+
 	@Override
 	public void setValueAt(Object value, int rowIndex, int columnIndex) {
-		throw new UnsupportedOperationException().msg("setting value in table");
-
+		assert (rowIndex < access.getParamCount() && columnIndex < columns.size());
+		// Object object = getObjectAt(rowIndex, columnIndex);
+		// if (object == null) {
+		//	return;
+		// }
+		columns.get(columnIndex).setValueAt(rowIndex, value);
 	}
 
-	public void addColumn(PrimitiveParam<?> columnParam) {
-		log.debug("added " + columnParam);
-		columnParams.add(columnParam);
+	public void addColumn(Column column) {
+		log.debug("added {}", column);
+		columns.add(column);
+	}
+
+	/**
+	 * @return the access
+	 */
+	public ListAccess getAccess() {
+		return access;
+	}
+
+	/**
+	 * @return the elementAccess
+	 */
+	public Access getElementAccess() {
+		return elementAccess;
 	}
 
@@ -101,6 +152,33 @@
 	 * @return the columnParams
 	 */
-	public List<PrimitiveParam<?>> getColumnParams() {
-		return Collections.unmodifiableList(columnParams);
+	public List<Column> getColumns() {
+		return Collections.unmodifiableList(columns);
+	}
+
+
+	public boolean addColumnIfSupported(Param param) {
+		if (param instanceof PrimitiveParam) {
+			addColumn(new PrimitiveColumn((PrimitiveParam<?>) param, this));
+			return true;
+		}
+		if (param instanceof ProcedureParam) {
+			if (((ProcedureParam) param).getArgumentsType().size() == 0) {
+				addColumn(new ProcedureColumn((ProcedureParam) param, this));
+				return true;
+			}
+			return false;
+		}
+		return false;
+	}
+
+	public static void transferCellAppeariance(JTable table, JComponent component, boolean isSelected) {
+		if (isSelected) {
+			component.setForeground(table.getSelectionForeground());
+			component.setBackground(table.getSelectionBackground());
+		} else {
+			component.setForeground(table.getForeground());
+			component.setBackground(UIManager.getColor("Button.background"));
+		}
+
 	}
 
Index: java/main/src/main/java/com/framsticks/gui/tree/AbstractNode.java
===================================================================
--- java/main/src/main/java/com/framsticks/gui/tree/AbstractNode.java	(revision 99)
+++ java/main/src/main/java/com/framsticks/gui/tree/AbstractNode.java	(revision 100)
@@ -1,3 +1,5 @@
 package com.framsticks.gui.tree;
+
+import com.framsticks.gui.AbstractPanel;
 
 
@@ -9,9 +11,11 @@
 
 	public abstract int getChildCount();
-	public abstract AbstractNode getChild(int number);
-	public abstract int getIndexOfChild(AbstractNode child);
+	public abstract Object getChild(int number);
+	public abstract int getIndexOfChild(Object child);
 
 	public abstract boolean isLeaf();
 	public abstract void render(TreeCellRenderer renderer);
 
+	public abstract AbstractPanel getPanel();
+
 }
Index: java/main/src/main/java/com/framsticks/gui/tree/MetaNode.java
===================================================================
--- java/main/src/main/java/com/framsticks/gui/tree/MetaNode.java	(revision 99)
+++ java/main/src/main/java/com/framsticks/gui/tree/MetaNode.java	(revision 100)
@@ -5,15 +5,25 @@
 
 
+import com.framsticks.gui.AbstractPanel;
+import com.framsticks.gui.Frame;
 import com.framsticks.gui.ImageProvider;
 
 public class MetaNode extends AbstractNode {
 
-	protected List<AbstractNode> children = new LinkedList<>();
+	protected final Frame frame;
+	protected final List<Object> children = new LinkedList<>();
 	protected String name = "meta node";
+
+	/**
+	 * @param frame
+	 */
+	public MetaNode(Frame frame) {
+		this.frame = frame;
+	}
 
 	/**
 	 * @return the children
 	 */
-	public List<AbstractNode> getChildren() {
+	public List<Object> getChildren() {
 		return children;
 	}
@@ -39,10 +49,10 @@
 
 	@Override
-	public AbstractNode getChild(int number) {
+	public Object getChild(int number) {
 		return children.get(number);
 	}
 
 	@Override
-	public int getIndexOfChild(AbstractNode child) {
+	public int getIndexOfChild(Object child) {
 		return children.indexOf(child);
 	}
@@ -65,3 +75,8 @@
 	}
 
+	@Override
+	public AbstractPanel getPanel() {
+		return frame.getEmptyPanel();
+	}
+
 }
Index: java/main/src/main/java/com/framsticks/gui/tree/TreeCellRenderer.java
===================================================================
--- java/main/src/main/java/com/framsticks/gui/tree/TreeCellRenderer.java	(revision 99)
+++ java/main/src/main/java/com/framsticks/gui/tree/TreeCellRenderer.java	(revision 100)
@@ -15,9 +15,12 @@
 public class TreeCellRenderer extends DefaultTreeCellRenderer {
 
-	public TreeCellRenderer() {
+	protected final TreeModel treeModel;
 
-		// setOpenIcon(ImageProvider.loadImage(ImageProvider.FOLDER_OPEN));
-		// setClosedIcon(ImageProvider.loadImage(ImageProvider.FOLDER_CLOSED));
-		// setLeafIcon(ImageProvider.loadImage(ImageProvider.NODE));
+
+	/**
+	 * @param treeModel
+	 */
+	public TreeCellRenderer(TreeModel treeModel) {
+		this.treeModel = treeModel;
 	}
 
@@ -35,6 +38,6 @@
 
 		if (!(value instanceof AbstractNode)) {
-			setIcon(ImageProvider.loadImage(ImageProvider.SERVER));
-			setText("framsticks");
+			setText("?");
+			// treeModel.renderTreeObject(Casting.throwCast(TreeNode.class, value), this);
 			return this;
 		}
@@ -92,4 +95,3 @@
 
 
-
 }
